import xmpp
from xmpp import cli
import config
from BotClass import JabberBot
import json
#раскомментировать, когда перейдем на разные пароли
import hashlib
from datetime import datetime

import time
import threading

#test
import jsonAndRequest as jsreq

global tasklist
global process_status

#В этом файле содержится только то, что запускает конкретный обработчик

# botname="open_strequest_assigned"
botname="open_template_bot"
operating_status=210
JID=botname+"@"+config.JSERVER
PORT=config.PORT

#раскомментировать, когда перейдем на разные пароли
PASSWORD=hashlib.md5((botname+config.PASSWORD).encode('utf-8')).hexdigest()

print(JID, PASSWORD)

#таким образом хранится список jid, от которых можно получать сообщения этому боту
listen_to=["test@ej.sharix-app.org", "open_template_bot@ej.sharix-app.org"]

#тут хранится список jid, кому бот может отправлять сообщения в результате обработки заявки
proceed_to=["open_template_bot@ej.sharix-app.org", "test@ej.sharix-app.org", "test1@ej.sharix-app.org", "open_servicerequest_forcemajeure@ej.sharix-app.org"]

#максимальное значение попыток обработать заказ
idle_value=10

# обработчик входящих сообщений
def message_handler(conn, mess):
    text = mess.getBody()#текст сообщения боту
    user = mess.getFrom()#отправитель сообщения
    #user = mess.getNode()#только jid 
   
   #нужна проверка, данный обработчик вообще должен от данного отправителя получать сообщения или нет. Подсказка ниже
    print (str(user).split("/")[0])
    if (str(user).split("/")[0]) in listen_to:
        print(text)
        print(mess)

        if text is not None:
            orderObj = jsreq.jsonToOrderTicket(text)
            print (orderObj)
            tasklist.append(orderObj)
            #process_status.append(0)
            bot.bot_log(str(datetime.now())+" Поступивший заказ успешно добавлен в очередь обработки\n")

def open_bot_template_wait(period, i,localtask):
    bot.bot_log(botname+" "+str(datetime.now())+" "+"Заказ ожидает\n")
    time.sleep(period)
    
    #ВАЖНО! Надо скорее всего через API редактировать заказ, иначе возможна потеря данных
    localtask.title=localtask.title+"1"

    #обязательно данный обработчик должен заканчиваться передачей заказа куда-то на обработку дальше - обратно или другому, иначе оно потеряется
    jsonTicket = json.dumps(localtask.__dict__)
    bot.proceed_status(proceed_to[0],jsonTicket)
    bot.bot_log(botname+" "+str(datetime.now())+" "+str(i)+" "+"Заказ подождал и возвращен в очередь\n")

def open_bot_template_process(localtask):
    bot.bot_log(botname+" "+str(datetime.now())+" "+"Заказ в обработчике\n")
    
    #ВАЖНО! Надо через API редактировать заказ, иначе возможна потеря данных
    #localtask.title +=1

    jsonTicket = json.dumps(localtask.__dict__)
    bot.proceed_status(proceed_to[1],jsonTicket)
    bot.bot_log(botname+" "+str(datetime.now())+" "+str(i)+" "+"Заказ успешно обработан\n")


def open_bot_template():
    #print("Тут описывается работа со списком задач в данном статусе")
    for i in range(len(tasklist)):
        #проверяем элемент tasklist[i]
        bot.bot_log(botname + " " + datetime.now().strftime('%Y-%m-%d') + " " + str(i) + " " + "Заказ в очереди на обработке\n")
        print ("EACH TASKLIST", tasklist[i])
        #print ("EACH TASKLIST", tasklist[i], process_status[i])
        localtask=tasklist.pop(i)
        
        #если боту почему-то пришла не его заявка - это явно ошибка движения процессов и отдаем в форсмажор - этот обработчик указывать стоит всегда последним
        if (localtask.status!=operating_status):
            jsonTicket = json.dumps(localtask.__dict__)
            bot.proceed_status(proceed_to[-1],jsonTicket)
            bot.bot_log(botname+" "+str(datetime.now())+" "+str(i)+" "+"Заказ не по адресу, перенаправляем на форсмажор\n")
            continue

        if (localtask.title!="10"):
            t1=threading.Thread(target=open_bot_template_wait, args=(5,i,localtask))
            t1.start()

        if (localtask.title=="101"):
            t1=threading.Thread(target=open_bot_template_process, args=(10,i,localtask))
            t1.start()

        #если никакие обработчики не подошли - отправляем обратно в очередь
        jsonTicket = json.dumps(localtask.__dict__)
        bot.proceed_status(proceed_to[0],jsonTicket)
        print("Заказ возвращен в очередь\n")
        print (tasklist)

#Авторизация и запуск бота

#пустой список заказов
tasklist = []

#надо инициализировать tasklist при запуске из API
token = jsreq.requestGetToken(botname, PASSWORD, config.API_URL+"/auth/token/login/")
#requestGetList(token, API_URL+"/tickets/api/tickets")

#ВАЖНО! Надо еще фильтровать список по статусу обработки заявки
tasklist=jsreq.requestGetList(token, config.API_URL+"/tickets/api/tickets/?list_id=10")
#tasklist=jsreq.requestGetList(token, config.API_URL+"/tickets/api/tickets")
#надо дописать таким образом, чтобы tasklist пополнялся тикетами определенного листа, а не всех
#print ("TASKLIST ", tasklist)
print (len(tasklist))

#список статусов обработки заказов
#process_status = []
#while len(process_status)<len(tasklist):
#    process_status.append(0)


bot = JabberBot(JID, PASSWORD, PORT)

#загружаем список заказов для обработки из базы (по идее, сюда попадаем в случае первого запуска или перезапуска)
bot.fake_api_call("Получаем список заказов по названию бота-обработчика")

bot.register_handler('message', message_handler)
bot.start(open_bot_template)



